{$M 16384,0,200000}

uses { Tvision: } views,app,editors,menus,objects,drivers,dialogs,gadgets,
     { Netz:    } isnet,
     { ASNE:    } global,uebersi,ausnahme,users,auscalc,
     { Temp.:   } msgbox,textview;

{$I mkgroup.pas }

type
  PApp = ^TApp;
  TApp = object(Tapplication)
    Clock: PClockView;
    Heap: PHeapView;
    constructor init;
    procedure Idle; virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure HandleEvent(var Event:TEvent); virtual;
  end;

constructor Tapp.Init;
var r:trect;
begin
{ wg. Bereichsberschreitung }
{  if maxavail div 16 < maxheapsize then
    maxheapsize:=((maxavail div 1024)-32) * (1024 div 16);}

  RegisterObjects;
  RegisterAusnahme;

  inherited init;

  r.assign(0,0,80,1);
  insert(new(PStaticText,init(r,
    ^c'Altenforst Schul-NEtz (ASNE)')));

  GetExtent(R); r.move(0,1);
  R.A.X := R.B.X - 6; R.B.Y := R.A.Y + 1;
  Clock := New(PClockView, Init(R));
  Insert(Clock);

  GetExtent(R);
  Dec(R.B.X);
  R.A.X := R.B.X - 9; R.A.Y := R.B.Y - 1;
  Heap := New(PHeapView, Init(R));
  heap^.growmode:=gfGrowAll;
  Insert(Heap);

  { einfacher Editor }
  {DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain]);
  EditorDialog := StdEditorDialog;
  ClipWindow := OpenEditor('', False);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;}
end;

procedure TApp.Idle;

begin
  inherited Idle;
  Clock^.Update;
  Heap^.Update;
end;


procedure TApp.InitMenuBar;
var r:trect;
begin
{  inc(desktop^.origin.y);
  dec(desktop^.size.y);}
  r.assign(0,1,80,2);
  MenuBar:=new(Pmenubar,init(r, newmenu(
    newSubMenu('~I~nfo',0,newmenu(
      newitem('bersicht','',0,cmUShow,0,
      newItem('Gruppe einrichten','',0,cmGrShow,0,
      nil))),
    newSubMenu('~A~usname',0,newmenu(
      newitem('bersicht','',0,cmAShow,0,
      newitem('neu berechnen','',0,cmAusnahmeRecalc,0,
      nil))),
    nil))
    )));
end;

procedure TApp.InitStatusLine;
var r:trect;
begin
  getExtent(r);
  r.a.y:=r.b.y-1;
  statusline:=new(PStatusLine,init(r,
    newStatusDef(0,0,
      newStatusKey('~Alt-X~ Ende',kbAltX,cmQuit,
      newStatusKey('~Alt-F3~ Fenster Schlieen',kbAltF3,cmClose,
      newStatusKey('~Strg-F5~ Fenster bewegen',kbCtrlF5,cmResize,
      nil))),
    nil)));
end;

procedure TApp.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(event);
  case event.what of
    evCommand:
      case Event.command of
        cmUShow : if not UebersichtActive then ShowUebersicht;
        cmAShow : if not AusnahmeActive then ShowAusnahme;
        cmGrShow: if not MkGroupActive then ShowMkGroup;
      else exit;
    end;
    else exit;
  end;
  clearevent(event);
end;

var
 Appl : Papp;
begin
  AusnahmeLoadList;

  Appl := new(Papp,init);
  {ShowUebersicht;}
  ShowAusnahme;
  Appl^.run;
  Appl^.done;

  AusnahmeSaveList;
end.
