unit auscalc;

INTERFACE

uses objects,nwmisc;

type
  {AusnahmeData = record
    typ:byte;
    case byte of
      0: (trustee_rights:word;
          trustee_path:string[127];  );
      1: (volume : string[40];
          space_restriction:longint; );
      2: (connections:byte;          );
      3: (password_required:boolean; );
      4: (password_length:byte;      );
      5: (group_member:string[40];   );
    end;}

  PAusnahme = ^TAusnahme;
  TAusnahme = object(TObject)
    obj_name:string[40];
    typ:byte;
    prop:string[127];
    value:string[127];
    marked:boolean;
    expire:tnovtime;
    constructor Load(var S: TStream);
    procedure Store(var S: TStream);
    function GetText(Maxlen:integer):string;
    function equal(t:byte;n,p,v:string):byte;
  end;

{procedure AusnahmeCalc(Coll:PCollection);}
procedure AusnahmeSaveList;
procedure AusnahmeLoadList;
procedure AusnahmeInsert(u:string;t:byte;p,v:string);
procedure RegisterAusnahme;

var AusnahmeList:PCollection;

IMPLEMENTATION

uses { ASNE } nwitype,nwiproc,tvutil,
     { NWTP } nwconn,nwbindry;

const
  RAusnahme: TStreamRec = (
    ObjType: 2097;
    VmtLink: Ofs(TypeOf(TAusnahme)^);
    Load: @TAusnahme.Load;
    Store:@TAusnahme.Store);


{ ############## TAusnahme ############################# }

constructor TAusnahme.load;
var version:byte;
begin
  s.read(version,1);
  if version<>1 then s.error(-7,0);
  s.read(obj_name,sizeof(obj_name));
  s.read(typ,sizeof(typ));
  s.read(prop,sizeof(prop));
  s.read(value,sizeof(value));
  s.read(marked,sizeof(marked));
  s.read(expire,sizeof(expire));
end;

procedure TAusnahme.store;
var version:byte;
begin
  version:=1;
  s.write(version,1); { version }
  s.write(obj_name,sizeof(obj_name));
  s.write(typ,sizeof(typ));
  s.write(prop,sizeof(prop));
  s.write(value,sizeof(value));
  s.write(marked,sizeof(marked));
  s.write(expire,sizeof(expire));
end;

function TAusnahme.GetText(Maxlen:integer):string;
var s:string;
begin
  s:=left(obj_name,10)+' ';
  case typ of
    1: s:=s+'Vrz-Recht   '+GetRights(str2int(prop))+' '+value;
    2: s:=s+'Vol Beschr  ';
    3: s:=s+'max Verbind ';
    4: s:=s+'PW bentigt ';
    5: s:=s+'min PWLnge ';
    6: s:=s+'in Gruppe   ';
    7: s:=s+'kein Home   ';
    8: s:=s+'Echter Name <nicht definiert>';
  else s:=s+'?         ?';
  end;
{  s:=s+' '+prop+' '+value;}
  gettext:=copy(s,1,maxlen);
end;


function TAusnahme.equal;
begin
  if (typ = t) and
     (obj_name = n) and
     (prop = p) and
     (value = v) then equal:=1;  { ok }
end;

{ ############## procedures ############################ }

procedure AusnahmeInsert(u:string;t:byte;p,v:string);
var x:PAusnahme;
begin
  x:=new(PAusnahme,init);
  x^.obj_name:=u;
  x^.typ:=t;
  x^.prop:=p;
  x^.value:=v;
  x^.marked:=false;
  AusnahmeList^.insert(x);
end;

procedure AusnahmeCalc(Coll:PCollection);

const na = '<nicht definiert>';

var users:PNWColl;
    LoginControlInfo:TloginControl;
    i:word;
begin
{  Coll^.freeAll;
  users:=new(PNWColl,init(1,1));
  getuser(users^);

  for i:=0 to users^.count-1 do
    with PNWUser(users^.at(i))^ do
      begin
        GetObjectLoginControl(Name,OT_USER,LoginControlInfo);
        with LoginControlInfo do
          if MinimumPasswordLength < 0 then
            MakeRec(name,5,int2str(MinimumPasswordLength),'');
          if getrealname(name)='' then
            MakeRec(name,8,na,'');
          MakeRec(name,1,'137','SYS:TEST');

      end;

  users^.done;
}
end;

procedure AusnahmeLoadList;
var s:tbufstream;
begin
  s.init('asne.aus',stOpenRead,2048);
  Ausnahmelist:=PCollection(s.get);
  if s.status <> 0 then
    begin
      AusNahmeList:=new(Pcollection,init(1,1));
    end;
  s.done;
end;

procedure AusnahmeSaveList;
var s:tbufstream;
begin
  s.init('asne.aus',stCreate,2048);
  s.put(AusnahmeList);
  s.done;
end;


procedure RegisterAusnahme;
begin
  RegisterType(RAusnahme);
end;

end.